import graph3;
import palette;
size(200);

currentprojection=orthographic(4,2,4);
currentlight=Viewport;

void atom(triple p, pen c, real R){
	draw(shift(p)*scale3(R)*unitsphere,c);
}


void link(triple p1, triple p2, pen c, real R){
	triple p = p1-p2;
	real phi = 180*asin(length(cross(Z,p))/length(p))/pi;
	draw(shift(p1)*rotate(-phi,cross(Z,p))*scale(R,R,length(p))*unitcylinder,lightgray);
}


real a = 3;
real b = 6;
triple mid = ((a,0,0) + rotate(60,Z)*(a,0,0))/3 + (0,0,b/2);
atom((0,0,0),red,1);
atom((0,0,b),red,1);
for(int i=0; i<6; ++i) atom(rotate(i*60,Z)*(a,0,0),red,1);
for(int i=0; i<6; ++i) atom(rotate(i*60,Z)*(a,0,b),red,1);
for(int i=0; i<3; ++i) atom(rotate(i*120,Z)*mid,blue,1.2);

for(int i=0; i<6; ++i) link(rotate(i*60,Z)*(a,0,0),rotate((i+1)*60,Z)*(a,0,0),lightgray,0.2);
for(int i=0; i<6; ++i) link(rotate(i*60,Z)*(a,0,b),rotate((i+1)*60,Z)*(a,0,b),lightgray,0.2);

