unitsize(1cm);

real L = 2;
real L2 = 2*L*cos(pi/6);



guide hex = rotate(-30)*(L,0) -- rotate(30)*(L,0) -- rotate(90)*(L,0) -- rotate(150)*(L,0) -- rotate(210)*(L,0) --  rotate(270)*(L,0) -- cycle;
filldraw(hex,lightgray);
draw((-L2,0)--(L2,0),Arrows);
draw(rotate(60)*((-L2,0)--(L2,0)),Arrows);
draw(rotate(-60)*((-L2,0)--(L2,0)),Arrows);

label("(6)",(L2,0),S);
label("(5)",rotate(60)*(L2,0),W);
label("(4)",rotate(120)*(L2,0),E);
label("(7)",rotate(180)*(L2,0),S);
label("(2)",rotate(240)*(L2,0),E);
label("(3)",rotate(300)*(L2,0),W);
label("(1)",(0,0),rotate(-10)*2*SW);

real fac = 0.8;

draw((0,0)--(fac*L2,0),dashed,EndArrow);
draw(rotate(90)*((0,0)--(fac*L2,0)),dashed,EndArrow);
label("$k_x$",(fac*L2,0),S);
label("$k_y$",rotate(90)*(fac*L2,0),E);

filldraw((0,0)--(cos(pi/6)*L,0) -- rotate(30)*(L,0) -- cycle ,gray);

