unitsize(1cm);
label(graphic("g","width=15cm, angle=0"),(0,0),NE);

pair s1 = truepoint(NE);

write(s1);

pair s2 = 0.8*s1;
pair deltay = (0,-0.8);

label("$\langle\Delta_1\rangle$",s2);
label("$\langle\Delta_2\rangle$",s2+deltay);
label("$\langle\Delta_3\rangle$",s2+2*deltay);
label(rotate(90)*"$\sin(x/\pi)+\sin(2x/\pi)$",(0.1*s1.x,s1.y/2),W);

label("$x$",(0.544*s1.x,0.08*s1.y));

arrow(scale(0.7)*minipage("Exemple de texte produit par l'environnement {\it minipage}",6cm),(0.55*s1.x,0.53*s1.y),NW,50);

arrow("Le cadre", (2,3), NE, 40);
