import three;
import solids;
size(250);

triple viewer= (3,-3,1.5); // (0,-6,4)
currentprojection = perspective(viewer);

real R = 0.7;
revolution upcone=cone((0,0,R),R,R,-Z);
revolution downcone=cone((0,0,-R),R,R,Z);
draw(surface(downcone),lightgray+opacity(0.2));
draw(surface(upcone),lightgray+opacity(0.2));

real L = 1;
draw((-L,0,0)--(L,0,0),blue);
draw((0,-L,0)--(0,L,0),blue);
draw((0,0,-L)--(0,0,L),blue);
label("$x$",(L,0,0),S);
label("$y$",(0,L,0),E);
label("$ct$",(0,0,L),E);

label("futur ($s^2>0$)",(0,0,0.7*L));
label("pass\'e ($s^2>0$)",(0,0,-0.7*L));
label("ailleurs ($s^2<0$)",(0.5,0.5,0));

